
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Service_auth_policiesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_auth_policies = await db.service_auth_policies.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        enforcement: data.enforcement
        ||
        null
            ,
            
        min_methods_required: data.min_methods_required
        ||
        null
            ,
            
        allow_precheck: data.allow_precheck
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await service_auth_policies.setService_type( data.service_type || null, {
            transaction,
        });
        
        await service_auth_policies.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        
        await service_auth_policies.setAllowed_methods(data.allowed_methods || [], {
            transaction,
        });
        

        

        return service_auth_policies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const service_auth_policiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                enforcement: item.enforcement
            ||
            null
            ,
            
                min_methods_required: item.min_methods_required
            ||
            null
            ,
            
                allow_precheck: item.allow_precheck
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const service_auth_policies = await db.service_auth_policies.bulkCreate(service_auth_policiesData, { transaction });

        // For each item created, replace relation files
        

        return service_auth_policies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const service_auth_policies = await db.service_auth_policies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.enforcement !== undefined) updatePayload.enforcement = data.enforcement;
        
        
        if (data.min_methods_required !== undefined) updatePayload.min_methods_required = data.min_methods_required;
        
        
        if (data.allow_precheck !== undefined) updatePayload.allow_precheck = data.allow_precheck;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await service_auth_policies.update(updatePayload, {transaction});

        
        
        if (data.service_type !== undefined) {
            await service_auth_policies.setService_type(
              
              data.service_type,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await service_auth_policies.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        
        if (data.allowed_methods !== undefined) {
            await service_auth_policies.setAllowed_methods(data.allowed_methods, { transaction });
        }
        

        

        return service_auth_policies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_auth_policies = await db.service_auth_policies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of service_auth_policies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of service_auth_policies) {
                await record.destroy({transaction});
            }
        });


        return service_auth_policies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const service_auth_policies = await db.service_auth_policies.findByPk(id, options);

        await service_auth_policies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await service_auth_policies.destroy({
            transaction
        });

        return service_auth_policies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const service_auth_policies = await db.service_auth_policies.findOne(
            { where },
            { transaction },
        );

        if (!service_auth_policies) {
            return service_auth_policies;
        }

        const output = service_auth_policies.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.authentication_sessions_service_auth_policy = await service_auth_policies.getAuthentication_sessions_service_auth_policy({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.service_type = await service_auth_policies.getService_type({
            transaction
        });
        
        
        output.allowed_methods = await service_auth_policies.getAllowed_methods({
            transaction
        });
        
        
        output.organizations = await service_auth_policies.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.service_types,
        as: 'service_type',
        
        where: filter.service_type ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_type.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.service_type.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },


      {
        model: db.authentication_methods,
        as: 'allowed_methods',
        required: false,
      },


    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_auth_policies',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            
            if (filter.min_methods_requiredRange) {
                const [start, end] = filter.min_methods_requiredRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    min_methods_required: {
                    ...where.min_methods_required,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    min_methods_required: {
                    ...where.min_methods_required,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.enforcement) {
                where = {
                    ...where,
                enforcement: filter.enforcement,
            };
            }
            
            if (filter.allow_precheck) {
                where = {
                    ...where,
                allow_precheck: filter.allow_precheck,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      


      if (filter.allowed_methods) {
        const searchTerms = filter.allowed_methods.split('|');

        include = [
          {
            model: db.authentication_methods,
            as: 'allowed_methods_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.service_auth_policies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'service_auth_policies',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.service_auth_policies.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

